#include <QObject>

#include <functional>
#include <memory>

#include "snake.h"

#include "Wima/WimaPlanData.h"

namespace routing {

class GeneratorBase : public QObject {
  Q_OBJECT
public:
  using Generator = std::function<bool(snake::Transects &)>;

  explicit GeneratorBase(QObject *parent = nullptr);
  ~GeneratorBase();

  virtual QString editorQML() = 0;
  virtual QString mapVisualQML() = 0;

  virtual QString name() = 0;
  virtual QString abbreviation() = 0;

  virtual bool get(const WimaPlanData &data, GeneratorBase &generator) = 0;

signals:
  void generatorChanged();
};

} // namespace routing
